class Parser {
    constructor (testString) {
        this.testString = testString;
        this.parsedString = null;
    }

    parse(str) {
        // (re)set parsedString to null
        this.parsedString = null;

        // If a string was passes in
        // make it the test string
        if (str) {
            this.testString = str;
        }
        
        // for result
        let res;

        try {
            // Try to parse string
            res = JSON.parse(this.testString);
        } catch (e) {
            // string didn't parse...
            try {
                // See if it's base64...
                let buff = new Buffer(this.testString, "base64");

                // Try to parse string
                res = JSON.parse(buff.toString("ascii"));
            } catch (x) {
                // string didn't parse
                res = null;
            }
        }
        if (res) {
            this.parsedString = res;
            return true;
        }
        return false;
    }
}
module.exports = Parser;
